// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'FileStorage.pas' rev: 6.00

#ifndef FileStorageHPP
#define FileStorageHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Classes.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Filestorage
{
//-- type declarations -------------------------------------------------------
typedef TList TStoredFiles;
;

class DELPHICLASS TStoredFile;
class DELPHICLASS TFileStorage;
class DELPHICLASS TAutoExtract;
class DELPHICLASS TExtractTo;
#pragma option push -b-
enum TToplevelDir { tdCurrentDir, tdWindowsDir, tdTempDir, tdSystemDir, tdMediaDir, tdCursorsDir, tdHelpDir, tdSamplesDir, tdDesktop, tdProgramFiles, tdMyDocuments, tdMyPictures, tdAppData, tdNone };
#pragma option pop

class PASCALIMPLEMENTATION TExtractTo : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FCreatePath;
	TToplevelDir FToplevelDir;
	AnsiString FSubdirectory;
	
public:
	AnsiString __fastcall Path();
	
__published:
	__property bool CreatePath = {read=FCreatePath, write=FCreatePath, default=1};
	__property TToplevelDir ToplevelDir = {read=FToplevelDir, write=FToplevelDir, default=0};
	__property AnsiString Subdirectory = {read=FSubdirectory, write=FSubdirectory};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TExtractTo(void) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TExtractTo(void) : Classes::TPersistent() { }
	#pragma option pop
	
};


#pragma option push -b-
enum TFileStorageOverwrite { owIfSizeDifferent, owNever, owAlways };
#pragma option pop

class PASCALIMPLEMENTATION TAutoExtract : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FEnabled;
	TExtractTo* FExtractTo;
	TFileStorageOverwrite FOverwrite;
	bool FRemoveOnTerminate;
	
public:
	__fastcall TAutoExtract(void);
	__fastcall virtual ~TAutoExtract(void);
	
__published:
	__property bool Enabled = {read=FEnabled, write=FEnabled, default=0};
	__property TExtractTo* ExtractTo = {read=FExtractTo, write=FExtractTo};
	__property TFileStorageOverwrite Overwrite = {read=FOverwrite, write=FOverwrite, default=0};
	__property bool RemoveOnTerminate = {read=FRemoveOnTerminate, write=FRemoveOnTerminate, default=0};
};


typedef void __fastcall (__closure *TOnExtractEvent)(System::TObject* Sender, AnsiString FileName, int FileSize, bool &AllowExtracting);

typedef void __fastcall (__closure *TOnExtractedEvent)(System::TObject* Sender, AnsiString FileName, int FileSize, bool Successfully);

class PASCALIMPLEMENTATION TFileStorage : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	TAutoExtract* FAutoExtract;
	Classes::TList* FFiles;
	Classes::TStringList* ExtractedFilesList;
	TOnExtractEvent FOnExtract;
	TOnExtractedEvent FOnExtracted;
	bool Compressed;
	int __fastcall GetDataSize(void);
	void __fastcall SetNone(const int Value);
	void __fastcall ReadData(Classes::TStream* Stream);
	void __fastcall WriteData(Classes::TStream* Stream);
	
protected:
	virtual void __fastcall Loaded(void);
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	
public:
	int FCount;
	__fastcall virtual TFileStorage(Classes::TComponent* aOwner);
	__fastcall virtual ~TFileStorage(void);
	bool __fastcall Extract(const AnsiString FileName, AnsiString OutputFile = "")/* overload */;
	bool __fastcall Extract(int FileIndex, AnsiString OutputFile = "")/* overload */;
	
__published:
	__property TAutoExtract* AutoExtract = {read=FAutoExtract, write=FAutoExtract};
	__property int Count = {read=FCount, write=SetNone, stored=false, nodefault};
	__property int DataSize = {read=GetDataSize, write=SetNone, stored=false, nodefault};
	__property Classes::TList* Files = {read=FFiles, write=FFiles, stored=false};
	__property TOnExtractEvent OnExtract = {read=FOnExtract, write=FOnExtract};
	__property TOnExtractedEvent OnExtracted = {read=FOnExtracted, write=FOnExtracted};
};


class PASCALIMPLEMENTATION TStoredFile : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TFileStorage* FOwner;
	AnsiString FFileName;
	int FSize;
	Classes::TMemoryStream* FData;
	virtual bool __fastcall Extract(const AnsiString FileName, bool CreatePath);
	
public:
	__fastcall TStoredFile(TFileStorage* aOwner);
	__fastcall virtual ~TStoredFile(void);
	void __fastcall ReadData(Classes::TStream* Stream);
	void __fastcall WriteData(Classes::TStream* Stream);
	bool __fastcall Upload(const AnsiString FileName);
	void __fastcall ClearData(void);
	__property AnsiString FileName = {read=FFileName, write=FFileName};
	__property int Size = {read=FSize, write=FSize, nodefault};
	__property Classes::TMemoryStream* Data = {read=FData, write=FData};
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Filestorage */
using namespace Filestorage;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// FileStorage
